\
\ polar.f
\ stepper.f & ps2m.f required
\
\ *chu* 15:02 20.11.2010
\
\ ==============================================================
\ !m -      
\ dx,dy -   ( ds - X  Y ) ,
\    ms -  

  marker -polar-

  decimal

  0 value stm0
  0 value stm1


  : steps!   ( stm_addr n -- )
	dup abs swap    0< if
	over -1 direction! else
	over  0 direction! then
	steps ! drop 
	;

 \   steps  
  : stm+!  ( ds stm_addr -- )
	over if
	dup stm_lock? if
	drop  drop    else
	dup   steps @ 
	rot + steps!  then
	else drop drop
	then
	;

  : run    ( stm_addr -- )
	dup steps @  0= if stm_unlock exit then
	dup steps @ over sequence c@ - over steps !
	dup step dly @ ms
	;

\
\ ==============================================================
\
 \
  : park!  ( stm_addr -- )
	dup stm_lock dup total @ negate steps!
	;

 \     
 \      
  : park?    ( dx dy ms )
	dup  r-btn and
	;

 \    
  : ?action  drop ;

 \
  : stm_control
	m? park?       
	if
	-rot drop drop
	stm0 park!
	stm1 park!
	else -rot
	stm0 stm+!
	stm1 stm+!  
	then ?action
	;
\
\ ==============================================================
\
  
  PORTA $F  stepper: altitude
  2 half-step altitude init_stm! altitude to stm0
  PORTA $F0 stepper: azimuth
  5 half-step azimuth  init_stm! azimuth  to stm1
  
  single onlytask

  $20 $20 task dup alsotask constant polar-control
  $20 $20 task dup alsotask constant polar-altitude
  $20 $20 task dup alsotask constant polar-azimuth
  $20 $20 task dup alsotask constant polar-stm?
  
  : task-control
	polar-control activate
	begin stm_control pause  again
	;

  : task-altitude
	polar-altitude activate
	begin altitude run pause again
	;

  : task-azimuth
	polar-azimuth activate
	begin azimuth run pause  again
	;

  : task-stm?
	
	['] tx   polar-stm? 14 + !	\ emit
	['] tx?  polar-stm? 16 + !	\ emit?
	polar-stm? activate
	begin stm0 stm? stm1 stm? pause again
	;

  : polar-go!
	!m task-control task-altitude task-azimuth multi
	;


