
\
\ tttt1.frt - timer1 tools for timing tests
\ 21:06 09.10.2010   *chu*
\ =============================================================
\

\  : .x base @ swap hex u. base ! ;

 marker -tttt1-

 forth only also assembler

 base @ hex
	2F constant tccr1a
	2E constant tccr1b
 base !

 \ stop timer1
  code t1>	
	tccr1b R2 out,	
  end-code

 \ start timer1 @ normal mode, prescaler=8 ( 1us counter @8MHz )
  code <t1
	R17    2   ldi,
	tccr1a R2  out,
	tccr1b R17 out,
  end-code

  code delay	\ : delay ( n -- ) begin 1- dup 0= until drop ;
       label> 
	R24  1  sbiw, 
       <radr    brne, 
	R24  Y+   ld, 
	R25  Y+   ld,
  end-code

 forth only decimal

 \  stop timer1 & zero counter
  : <t1>  t1> 0 dup TCNT1H c! TCNT1L c!	;

 \  show t1 counter
  : .t1
	TCNT1L c@ TCNT1H c@ 8 lshift + dup
	." (0x" .x ." )" bl emit u. ." us" 
	TIFR c@ 4 and dup		\ test TOV1 flag
	if bl emit ." overrun" 
	   TIFR c@ or TIFR c!		\ clear TOV1 by writing'1'
	else drop then  cr
 	;

 \ timing test using timer1, xt - executable ...
  : ?us   <t1> <t1 execute t1> .t1 ;	( *x xt -- *y )
          	
\
\ =============================================================
\

